package be.iminds.ilabt.jfed.espec.bundle;

import be.iminds.ilabt.jfed.espec.model.ExperimentSpecification;

import javax.annotation.Nonnull;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.List;

/**
 * Bundle a collections of files, which contains the ExperimentSpecification description yaml file
 */
public interface ESpecBundle {
    static String ESPEC_DESCRIPTION_FILENAME = "experiment-specification.yml";

    @Nonnull List<String> getFileNames();
    @Nonnull byte[] getFileContent(@Nonnull String fileName) throws IOException;
    boolean isDir(@Nonnull String fileName) throws IOException;

    @Nonnull
    default String getExperimentSpecificationYml() throws IOException {
        assert getFileNames().contains(ESPEC_DESCRIPTION_FILENAME);
        return new String(getFileContent(ESPEC_DESCRIPTION_FILENAME), StandardCharsets.UTF_8);
    }

    @Nonnull
    ExperimentSpecification getExperimentSpecification();
}
